<?php

namespace FiloBlu\Storelocator\Model\Plugin\Rma\Item;

use FiloBlu\Storelocator\Helper\Data;
use Magento\Store\Model\StoreManagerInterface;

class Status
{
    /**
     * @var Data
     */
    protected $helper;
    /**
     * @var StoreManagerInterface
     */
    protected $storeManager;

    /**
     * @param Data $helper
     * @param StoreManagerInterface $storeManager
     */
    public function __construct(
        Data $helper,
        StoreManagerInterface $storeManager
    ) {
        $this->helper = $helper;
        $this->storeManager = $storeManager;
    }

    public function afterGetAllowedStatuses(\Magento\Rma\Model\Item\Status $subject, $result)
    {
        $storeId = $this->storeManager->getStore()->getId();

        if (!$this->helper->getReturnToStoreEnabled($storeId)) {
            return $result;
        }

        if (in_array(
            $subject->getStatus(),
            ['authorized', 'received', \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE]
        )) {
            if (count($result)) {
                $result[\FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE] = __(
                    \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE_PHRASE
                );
            } else {
                $result = [
                    \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_RECEIVED => ucfirst(
                        \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_RECEIVED
                    ),
                    \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_APPROVED => ucfirst(
                        \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_APPROVED
                    ),
                    \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_REJECTED => ucfirst(
                        \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_REJECTED
                    ),
                    \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE => \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE_PHRASE
                ];
            }
        }

        return $result;
    }

    public function afterGetAttributeIsEditable(\Magento\Rma\Model\Item\Status $subject, $result, $attribute = null)
    {
        if ($subject->getStatus() == \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE) {
            return true;
        }

        return $result;
    }
}